PertFoldChange <- function(
       gct.file,                                # Input dataset with replicates
	   DNA.reference.file,						# DNA replicate means (for each sample, using appropriate DNA replicates) with same dimension as Input dataset
       extension                             	# output filename prefix
)
  {
  # source('/rnai/achilles2/Barbara/scripts/R/common2.R')
  # source('/rnai/achilles2/Barbara/scripts/R/Achilles_common.R')
   
	print("Reading gct file.")
### Read gct file 
	dataset <- MSIG.Gct2Frame(filename = gct.file)
###m2 has the actual scores from the gct file
	m2 <- data.matrix(dataset$ds)
	reagent <- dataset$row.names

	print("Reading DNA reference file.")
### Read gct file 
	dna <- MSIG.Gct2Frame(filename = DNA.reference.file)
	d2 <- data.matrix(dna$ds)
	reagent1 <- dna$row.names

###	Calculate fold change element by element (gct.file and DNA.reference.file are same dimensions)	
	fc<-(m2-d2)
	fc<-round(fc, digits=6) 
	
### identify and remove DNA reference columns, if still present  
	dname<- toupper(colnames(dataset$ds))
	dname<-strsplit(dname,"REP")
	screened <- matrix(data=0,nrow=length(colnames(dataset$ds)),ncol=1)
	for (j in 1:length(colnames(dataset$ds)))
		{ screened[j]<- dname[[j]][[1]] }
	screened <-  gsub('[[:punct:]]', '', screened)
	screened <-  gsub('[[:blank:]]', '', screened)
	reference <- grep("PDNA",screened)
	keep<-setdiff(1:length(colnames(dataset$ds)),reference)
	
	gct<-{}
	gct$data<-fc[,keep]
	gct$row.descriptions<-reagent
	gct$rows<-reagent
	write.gct.nan(gct,paste(extension,"FC.gct", sep='_'))
	
	Module_Stats(dataset,gct)
}



Module_Stats <- function(in.gct,out.gct){
  ## Check gct files and see the change in number of cell lines, etc.
  
  ## look for number of rows, columns in the out$data matrix
  
  nLinesIn = ncol(in.gct$ds)
  nLinesOut = ncol(out.gct$data)
  
  nGuidesIn = nrow(in.gct$ds)
  nGuidesOut = nrow(out.gct$data)
  
  
  # Make List of things you are checking
  
  Module.Stats = {}
  Module.Stats$Parameter = c('nLinesIn','nLinesOut','nGuidesIn','nGuidesOut')
  Module.Stats$Stats = c(nLinesIn,nLinesOut,nGuidesIn,nGuidesOut)
  
  #...other stats as necessary
  
  Module.Stats = as.data.frame(Module.Stats)
  
  write.table(Module.Stats,'Module_Stats.txt',quote = FALSE,sep = "\t",row.names = FALSE)
}