## The Broad Institute
## SOFTWARE COPYRIGHT NOTICE AGREEMENT
## This software and its documentation are copyright (2013) by the
## Broad Institute/Massachusetts Institute of Technology. All rights are
## reserved.
##
## This software is supplied without any warranty or guaranteed support
## whatsoever. Neither the Broad Institute nor MIT can be responsible for its
## use, misuse, or functionality.

args <- commandArgs(trailingOnly=TRUE)

vers <- "2.15"            # R version
libdir <- args[1]
server.dir <- args[2]
patch.dir <- args[3]

source(file.path(libdir, "loadRLibrary.R"))
load.packages(libdir, patch.dir, server.dir, vers)

option_list <- list(
  make_option("--gct.file", dest="gct.file"),
  make_option("--DNA.reference.file", dest="DNA.reference.file"),
  make_option("--extension", dest="extension")
  )

opt <- parse_args(OptionParser(option_list=option_list), positional_arguments=TRUE, args=args)
print(opt)
opts <- opt$options

# returns string w/o leading or trailing whitespace
#trim <- function (x) gsub("^\\s+|\\s+$", "", x)
# Returns NULL if the value is blank or a numeric if the value parses as numeric.
# Otherwise it stops execution with an error.
#require.numeric.or.null <- function(value, paramName) {
#  if (is.null(value)) { return(NULL) }
#  trimmedValue = trim(value)
#  if (trimmedValue == "") { return(NULL) }
#  suppressWarnings(val <- as.numeric(trimmedValue))
#  if (is.na(val)) {
#      stop(paste("The parameter '", paramName, "' must be numeric or blank.  Received '", value, "'.", sep=""))  
#  }
#  return(val)
#}

source(file.path(libdir, "common2.R"))
source(file.path(libdir, "Achilles_common.R"))
source(file.path(libdir, "PertFoldChange.R"))

sessionInfo()

PertFoldChange(opts$gct.file, opts$DNA.reference.file, opts$extension)